<?php

/**
 * Subclass for representing a row from the 'microcycle' table.
 *
 *
 *
 * @package lib.model
 */
class Microcycle extends BaseMicrocycle
{
	public function __toString() {
		return parent::getDescription();
	}

	public function save($con=null){
		$con = Propel::getConnection();
		try
		{
			$con->begin();

			$ret = parent::save($con);

			//add all the sessions to the microcicle
			$date = new DateTime( $this->getStartAt('Y-m-d'));
			$endDate= new DateTime($this->getLastDayAt('Y-m-d'));
			while (strtotime(date_format($endDate,'Y-m-d'))>=strtotime(date_format($date,'Y-m-d'))) {
				$session=new Session();
				$session->setDate(date_format($date,'Y-m-d'));
				$session->setMorningSession(true);
				$this->addSession($session);
				$session->save($con);
				$date->modify("+1 day");
			}

			$con->commit();

			return $ret;
		}
		catch (Exception $e)
		{
			$con->rollback();
			throw $e;
		}

	}
}
