<?php



class MacrocycleMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.MacrocycleMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('macrocycle');
		$tMap->setPhpName('Macrocycle');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 250);

		$tMap->addColumn('START_AT', 'StartAt', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('LAST_DAY_AT', 'LastDayAt', 'int', CreoleTypes::DATE, false, null);

		$tMap->addForeignKey('SEASON_ID', 'SeasonId', 'int', CreoleTypes::INTEGER, 'season', 'ID', false, null);

		$tMap->addColumn('THEORIC_INTENSITY', 'TheoricIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_VOLUME', 'TheoricVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY', 'ReportedIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_VOLUME', 'ReportedVolume', 'double', CreoleTypes::DOUBLE, false, null);

	} 
} 