<?php


abstract class BaseConversionFactor extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $origin_id;


	
	protected $destiny_id;


	
	protected $conversion_factor;

	
	protected $aUnitRelatedByOriginId;

	
	protected $aUnitRelatedByDestinyId;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getOriginId()
	{

		return $this->origin_id;
	}

	
	public function getDestinyId()
	{

		return $this->destiny_id;
	}

	
	public function getConversionFactor()
	{

		return $this->conversion_factor;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ConversionFactorPeer::ID;
		}

	} 
	
	public function setOriginId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->origin_id !== $v) {
			$this->origin_id = $v;
			$this->modifiedColumns[] = ConversionFactorPeer::ORIGIN_ID;
		}

		if ($this->aUnitRelatedByOriginId !== null && $this->aUnitRelatedByOriginId->getId() !== $v) {
			$this->aUnitRelatedByOriginId = null;
		}

	} 
	
	public function setDestinyId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->destiny_id !== $v) {
			$this->destiny_id = $v;
			$this->modifiedColumns[] = ConversionFactorPeer::DESTINY_ID;
		}

		if ($this->aUnitRelatedByDestinyId !== null && $this->aUnitRelatedByDestinyId->getId() !== $v) {
			$this->aUnitRelatedByDestinyId = null;
		}

	} 
	
	public function setConversionFactor($v)
	{

		if ($this->conversion_factor !== $v) {
			$this->conversion_factor = $v;
			$this->modifiedColumns[] = ConversionFactorPeer::CONVERSION_FACTOR;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->origin_id = $rs->getInt($startcol + 1);

			$this->destiny_id = $rs->getInt($startcol + 2);

			$this->conversion_factor = $rs->getFloat($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConversionFactor object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConversionFactorPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConversionFactorPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConversionFactorPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUnitRelatedByOriginId !== null) {
				if ($this->aUnitRelatedByOriginId->isModified() || $this->aUnitRelatedByOriginId->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnitRelatedByOriginId->save($con);
				}
				$this->setUnitRelatedByOriginId($this->aUnitRelatedByOriginId);
			}

			if ($this->aUnitRelatedByDestinyId !== null) {
				if ($this->aUnitRelatedByDestinyId->isModified() || $this->aUnitRelatedByDestinyId->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnitRelatedByDestinyId->save($con);
				}
				$this->setUnitRelatedByDestinyId($this->aUnitRelatedByDestinyId);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConversionFactorPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConversionFactorPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUnitRelatedByOriginId !== null) {
				if (!$this->aUnitRelatedByOriginId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitRelatedByOriginId->getValidationFailures());
				}
			}

			if ($this->aUnitRelatedByDestinyId !== null) {
				if (!$this->aUnitRelatedByDestinyId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitRelatedByDestinyId->getValidationFailures());
				}
			}


			if (($retval = ConversionFactorPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConversionFactorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getOriginId();
				break;
			case 2:
				return $this->getDestinyId();
				break;
			case 3:
				return $this->getConversionFactor();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConversionFactorPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getOriginId(),
			$keys[2] => $this->getDestinyId(),
			$keys[3] => $this->getConversionFactor(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConversionFactorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setOriginId($value);
				break;
			case 2:
				$this->setDestinyId($value);
				break;
			case 3:
				$this->setConversionFactor($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConversionFactorPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setOriginId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setDestinyId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setConversionFactor($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConversionFactorPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConversionFactorPeer::ID)) $criteria->add(ConversionFactorPeer::ID, $this->id);
		if ($this->isColumnModified(ConversionFactorPeer::ORIGIN_ID)) $criteria->add(ConversionFactorPeer::ORIGIN_ID, $this->origin_id);
		if ($this->isColumnModified(ConversionFactorPeer::DESTINY_ID)) $criteria->add(ConversionFactorPeer::DESTINY_ID, $this->destiny_id);
		if ($this->isColumnModified(ConversionFactorPeer::CONVERSION_FACTOR)) $criteria->add(ConversionFactorPeer::CONVERSION_FACTOR, $this->conversion_factor);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConversionFactorPeer::DATABASE_NAME);

		$criteria->add(ConversionFactorPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setOriginId($this->origin_id);

		$copyObj->setDestinyId($this->destiny_id);

		$copyObj->setConversionFactor($this->conversion_factor);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConversionFactorPeer();
		}
		return self::$peer;
	}

	
	public function setUnitRelatedByOriginId($v)
	{


		if ($v === null) {
			$this->setOriginId(NULL);
		} else {
			$this->setOriginId($v->getId());
		}


		$this->aUnitRelatedByOriginId = $v;
	}


	
	public function getUnitRelatedByOriginId($con = null)
	{
		if ($this->aUnitRelatedByOriginId === null && ($this->origin_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnitRelatedByOriginId = UnitPeer::retrieveByPK($this->origin_id, $con);

			
		}
		return $this->aUnitRelatedByOriginId;
	}

	
	public function setUnitRelatedByDestinyId($v)
	{


		if ($v === null) {
			$this->setDestinyId(NULL);
		} else {
			$this->setDestinyId($v->getId());
		}


		$this->aUnitRelatedByDestinyId = $v;
	}


	
	public function getUnitRelatedByDestinyId($con = null)
	{
		if ($this->aUnitRelatedByDestinyId === null && ($this->destiny_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnitRelatedByDestinyId = UnitPeer::retrieveByPK($this->destiny_id, $con);

			
		}
		return $this->aUnitRelatedByDestinyId;
	}

} 