<?php


abstract class BaseFeedbackType extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $global_description;


	
	protected $coach_id;

	
	protected $aUser;

	
	protected $collFeedbackTypeI18Ns;

	
	protected $lastFeedbackTypeI18NCriteria = null;

	
	protected $collElementFeedbacks;

	
	protected $lastElementFeedbackCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getGlobalDescription()
	{

		return $this->global_description;
	}

	
	public function getCoachId()
	{

		return $this->coach_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FeedbackTypePeer::ID;
		}

	} 
	
	public function setGlobalDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->global_description !== $v) {
			$this->global_description = $v;
			$this->modifiedColumns[] = FeedbackTypePeer::GLOBAL_DESCRIPTION;
		}

	} 
	
	public function setCoachId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->coach_id !== $v) {
			$this->coach_id = $v;
			$this->modifiedColumns[] = FeedbackTypePeer::COACH_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->global_description = $rs->getString($startcol + 1);

			$this->coach_id = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating FeedbackType object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedbackTypePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FeedbackTypePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedbackTypePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FeedbackTypePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FeedbackTypePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collFeedbackTypeI18Ns !== null) {
				foreach($this->collFeedbackTypeI18Ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collElementFeedbacks !== null) {
				foreach($this->collElementFeedbacks as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}


			if (($retval = FeedbackTypePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collFeedbackTypeI18Ns !== null) {
					foreach($this->collFeedbackTypeI18Ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collElementFeedbacks !== null) {
					foreach($this->collElementFeedbacks as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedbackTypePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getGlobalDescription();
				break;
			case 2:
				return $this->getCoachId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedbackTypePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getGlobalDescription(),
			$keys[2] => $this->getCoachId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedbackTypePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setGlobalDescription($value);
				break;
			case 2:
				$this->setCoachId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedbackTypePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setGlobalDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCoachId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FeedbackTypePeer::DATABASE_NAME);

		if ($this->isColumnModified(FeedbackTypePeer::ID)) $criteria->add(FeedbackTypePeer::ID, $this->id);
		if ($this->isColumnModified(FeedbackTypePeer::GLOBAL_DESCRIPTION)) $criteria->add(FeedbackTypePeer::GLOBAL_DESCRIPTION, $this->global_description);
		if ($this->isColumnModified(FeedbackTypePeer::COACH_ID)) $criteria->add(FeedbackTypePeer::COACH_ID, $this->coach_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FeedbackTypePeer::DATABASE_NAME);

		$criteria->add(FeedbackTypePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setGlobalDescription($this->global_description);

		$copyObj->setCoachId($this->coach_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getFeedbackTypeI18Ns() as $relObj) {
				$copyObj->addFeedbackTypeI18N($relObj->copy($deepCopy));
			}

			foreach($this->getElementFeedbacks() as $relObj) {
				$copyObj->addElementFeedback($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FeedbackTypePeer();
		}
		return self::$peer;
	}

	
	public function setUser($v)
	{


		if ($v === null) {
			$this->setCoachId(NULL);
		} else {
			$this->setCoachId($v->getId());
		}


		$this->aUser = $v;
	}


	
	public function getUser($con = null)
	{
		if ($this->aUser === null && ($this->coach_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUser = UserPeer::retrieveByPK($this->coach_id, $con);

			
		}
		return $this->aUser;
	}

	
	public function initFeedbackTypeI18Ns()
	{
		if ($this->collFeedbackTypeI18Ns === null) {
			$this->collFeedbackTypeI18Ns = array();
		}
	}

	
	public function getFeedbackTypeI18Ns($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackTypeI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFeedbackTypeI18Ns === null) {
			if ($this->isNew()) {
			   $this->collFeedbackTypeI18Ns = array();
			} else {

				$criteria->add(FeedbackTypeI18NPeer::ID, $this->getId());

				FeedbackTypeI18NPeer::addSelectColumns($criteria);
				$this->collFeedbackTypeI18Ns = FeedbackTypeI18NPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(FeedbackTypeI18NPeer::ID, $this->getId());

				FeedbackTypeI18NPeer::addSelectColumns($criteria);
				if (!isset($this->lastFeedbackTypeI18NCriteria) || !$this->lastFeedbackTypeI18NCriteria->equals($criteria)) {
					$this->collFeedbackTypeI18Ns = FeedbackTypeI18NPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFeedbackTypeI18NCriteria = $criteria;
		return $this->collFeedbackTypeI18Ns;
	}

	
	public function countFeedbackTypeI18Ns($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackTypeI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(FeedbackTypeI18NPeer::ID, $this->getId());

		return FeedbackTypeI18NPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addFeedbackTypeI18N(FeedbackTypeI18N $l)
	{
		$this->collFeedbackTypeI18Ns[] = $l;
		$l->setFeedbackType($this);
	}

	
	public function initElementFeedbacks()
	{
		if ($this->collElementFeedbacks === null) {
			$this->collElementFeedbacks = array();
		}
	}

	
	public function getElementFeedbacks($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
			   $this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

				ElementFeedbackPeer::addSelectColumns($criteria);
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

				ElementFeedbackPeer::addSelectColumns($criteria);
				if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
					$this->collElementFeedbacks = ElementFeedbackPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;
		return $this->collElementFeedbacks;
	}

	
	public function countElementFeedbacks($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

		return ElementFeedbackPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addElementFeedback(ElementFeedback $l)
	{
		$this->collElementFeedbacks[] = $l;
		$l->setFeedbackType($this);
	}


	
	public function getElementFeedbacksJoinUnit($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
				$this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		} else {
									
			$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

			if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;

		return $this->collElementFeedbacks;
	}


	
	public function getElementFeedbacksJoinSessionElement($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
				$this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinSessionElement($criteria, $con);
			}
		} else {
									
			$criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->getId());

			if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinSessionElement($criteria, $con);
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;

		return $this->collElementFeedbacks;
	}

  public function getCulture()
  {
    return $this->culture;
  }

  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getDescription()
  {
    $obj = $this->getCurrentFeedbackTypeI18N();

    return ($obj ? $obj->getDescription() : null);
  }

  public function setDescription($value)
  {
    $this->getCurrentFeedbackTypeI18N()->setDescription($value);
  }

  protected $current_i18n = array();

  public function getCurrentFeedbackTypeI18N()
  {
    if (!isset($this->current_i18n[$this->culture]))
    {
      $obj = FeedbackTypeI18NPeer::retrieveByPK($this->getId(), $this->culture);
      if ($obj)
      {
        $this->setFeedbackTypeI18NForCulture($obj, $this->culture);
      }
      else
      {
        $this->setFeedbackTypeI18NForCulture(new FeedbackTypeI18N(), $this->culture);
        $this->current_i18n[$this->culture]->setCulture($this->culture);
      }
    }

    return $this->current_i18n[$this->culture];
  }

  public function setFeedbackTypeI18NForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addFeedbackTypeI18N($object);
  }

} 