<?php


abstract class BaseMicrocyclePeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'microcycle';

	
	const CLASS_DEFAULT = 'lib.model.Microcycle';

	
	const NUM_COLUMNS = 9;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'microcycle.ID';

	
	const DESCRIPTION = 'microcycle.DESCRIPTION';

	
	const START_AT = 'microcycle.START_AT';

	
	const LAST_DAY_AT = 'microcycle.LAST_DAY_AT';

	
	const MESOCYCLE_ID = 'microcycle.MESOCYCLE_ID';

	
	const THEORIC_INTENSITY = 'microcycle.THEORIC_INTENSITY';

	
	const THEORIC_VOLUME = 'microcycle.THEORIC_VOLUME';

	
	const REPORTED_INTENSITY = 'microcycle.REPORTED_INTENSITY';

	
	const REPORTED_VOLUME = 'microcycle.REPORTED_VOLUME';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'Description', 'StartAt', 'LastDayAt', 'MesocycleId', 'TheoricIntensity', 'TheoricVolume', 'ReportedIntensity', 'ReportedVolume', ),
		BasePeer::TYPE_COLNAME => array (MicrocyclePeer::ID, MicrocyclePeer::DESCRIPTION, MicrocyclePeer::START_AT, MicrocyclePeer::LAST_DAY_AT, MicrocyclePeer::MESOCYCLE_ID, MicrocyclePeer::THEORIC_INTENSITY, MicrocyclePeer::THEORIC_VOLUME, MicrocyclePeer::REPORTED_INTENSITY, MicrocyclePeer::REPORTED_VOLUME, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'description', 'start_at', 'last_day_at', 'mesocycle_id', 'theoric_intensity', 'theoric_volume', 'reported_intensity', 'reported_volume', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Description' => 1, 'StartAt' => 2, 'LastDayAt' => 3, 'MesocycleId' => 4, 'TheoricIntensity' => 5, 'TheoricVolume' => 6, 'ReportedIntensity' => 7, 'ReportedVolume' => 8, ),
		BasePeer::TYPE_COLNAME => array (MicrocyclePeer::ID => 0, MicrocyclePeer::DESCRIPTION => 1, MicrocyclePeer::START_AT => 2, MicrocyclePeer::LAST_DAY_AT => 3, MicrocyclePeer::MESOCYCLE_ID => 4, MicrocyclePeer::THEORIC_INTENSITY => 5, MicrocyclePeer::THEORIC_VOLUME => 6, MicrocyclePeer::REPORTED_INTENSITY => 7, MicrocyclePeer::REPORTED_VOLUME => 8, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'description' => 1, 'start_at' => 2, 'last_day_at' => 3, 'mesocycle_id' => 4, 'theoric_intensity' => 5, 'theoric_volume' => 6, 'reported_intensity' => 7, 'reported_volume' => 8, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, )
	);

	
	public static function getMapBuilder()
	{
		include_once 'lib/model/map/MicrocycleMapBuilder.php';
		return BasePeer::getMapBuilder('lib.model.map.MicrocycleMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = MicrocyclePeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(MicrocyclePeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(MicrocyclePeer::ID);

		$criteria->addSelectColumn(MicrocyclePeer::DESCRIPTION);

		$criteria->addSelectColumn(MicrocyclePeer::START_AT);

		$criteria->addSelectColumn(MicrocyclePeer::LAST_DAY_AT);

		$criteria->addSelectColumn(MicrocyclePeer::MESOCYCLE_ID);

		$criteria->addSelectColumn(MicrocyclePeer::THEORIC_INTENSITY);

		$criteria->addSelectColumn(MicrocyclePeer::THEORIC_VOLUME);

		$criteria->addSelectColumn(MicrocyclePeer::REPORTED_INTENSITY);

		$criteria->addSelectColumn(MicrocyclePeer::REPORTED_VOLUME);

	}

	const COUNT = 'COUNT(microcycle.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT microcycle.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = MicrocyclePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = MicrocyclePeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return MicrocyclePeer::populateObjects(MicrocyclePeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			MicrocyclePeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = MicrocyclePeer::getOMClass();
		$cls = Propel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	
	public static function doCountJoinMesocycle(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);

		$rs = MicrocyclePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinMesocycle(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		MicrocyclePeer::addSelectColumns($c);
		$startcol = (MicrocyclePeer::NUM_COLUMNS - MicrocyclePeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		MesocyclePeer::addSelectColumns($c);

		$c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = MicrocyclePeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = MesocyclePeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getMesocycle(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addMicrocycle($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initMicrocycles();
				$obj2->addMicrocycle($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(MicrocyclePeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);

		$rs = MicrocyclePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		MicrocyclePeer::addSelectColumns($c);
		$startcol2 = (MicrocyclePeer::NUM_COLUMNS - MicrocyclePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		MesocyclePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + MesocyclePeer::NUM_COLUMNS;

		$c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = MicrocyclePeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


					
			$omClass = MesocyclePeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getMesocycle(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addMicrocycle($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj2->initMicrocycles();
				$obj2->addMicrocycle($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}

	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return MicrocyclePeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}

		$criteria->remove(MicrocyclePeer::ID); 

				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(MicrocyclePeer::ID);
			$selectCriteria->add(MicrocyclePeer::ID, $criteria->remove(MicrocyclePeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(MicrocyclePeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(MicrocyclePeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof Microcycle) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(MicrocyclePeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(Microcycle $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(MicrocyclePeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(MicrocyclePeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(MicrocyclePeer::DATABASE_NAME, MicrocyclePeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = MicrocyclePeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(MicrocyclePeer::DATABASE_NAME);

		$criteria->add(MicrocyclePeer::ID, $pk);


		$v = MicrocyclePeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(MicrocyclePeer::ID, $pks, Criteria::IN);
			$objs = MicrocyclePeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseMicrocyclePeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			require_once 'lib/model/map/MicrocycleMapBuilder.php';
	Propel::registerMapBuilder('lib.model.map.MicrocycleMapBuilder');
}
