<?php


abstract class BaseSession extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $date;


	
	protected $morning_session;


	
	protected $feedback;


	
	protected $microcycle_id;


	
	protected $wake_up_hr;


	
	protected $theoric_intensity;


	
	protected $theoric_volume;


	
	protected $reported_intensity;


	
	protected $reported_volume;


	
	protected $l_ccl;


	
	protected $ccl;


	
	protected $ccm;


	
	protected $uam;


	
	protected $m_uam;


	
	protected $lact1;


	
	protected $lact2;

	
	protected $aMicrocycle;

	
	protected $collFeedbacks;

	
	protected $lastFeedbackCriteria = null;

	
	protected $collSessionElements;

	
	protected $lastSessionElementCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDate($format = 'Y-m-d')
	{

		if ($this->date === null || $this->date === '') {
			return null;
		} elseif (!is_int($this->date)) {
						$ts = strtotime($this->date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [date] as date/time value: " . var_export($this->date, true));
			}
		} else {
			$ts = $this->date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getMorningSession()
	{

		return $this->morning_session;
	}

	
	public function getFeedback()
	{

		return $this->feedback;
	}

	
	public function getMicrocycleId()
	{

		return $this->microcycle_id;
	}

	
	public function getWakeUpHr()
	{

		return $this->wake_up_hr;
	}

	
	public function getTheoricIntensity()
	{

		return $this->theoric_intensity;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedIntensity()
	{

		return $this->reported_intensity;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function getLCcl()
	{

		return $this->l_ccl;
	}

	
	public function getCcl()
	{

		return $this->ccl;
	}

	
	public function getCcm()
	{

		return $this->ccm;
	}

	
	public function getUam()
	{

		return $this->uam;
	}

	
	public function getMUam()
	{

		return $this->m_uam;
	}

	
	public function getLact1()
	{

		return $this->lact1;
	}

	
	public function getLact2()
	{

		return $this->lact2;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SessionPeer::ID;
		}

	} 
	
	public function setDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->date !== $ts) {
			$this->date = $ts;
			$this->modifiedColumns[] = SessionPeer::DATE;
		}

	} 
	
	public function setMorningSession($v)
	{

		if ($this->morning_session !== $v) {
			$this->morning_session = $v;
			$this->modifiedColumns[] = SessionPeer::MORNING_SESSION;
		}

	} 
	
	public function setFeedback($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->feedback !== $v) {
			$this->feedback = $v;
			$this->modifiedColumns[] = SessionPeer::FEEDBACK;
		}

	} 
	
	public function setMicrocycleId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->microcycle_id !== $v) {
			$this->microcycle_id = $v;
			$this->modifiedColumns[] = SessionPeer::MICROCYCLE_ID;
		}

		if ($this->aMicrocycle !== null && $this->aMicrocycle->getId() !== $v) {
			$this->aMicrocycle = null;
		}

	} 
	
	public function setWakeUpHr($v)
	{

		if ($this->wake_up_hr !== $v) {
			$this->wake_up_hr = $v;
			$this->modifiedColumns[] = SessionPeer::WAKE_UP_HR;
		}

	} 
	
	public function setTheoricIntensity($v)
	{

		if ($this->theoric_intensity !== $v) {
			$this->theoric_intensity = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_INTENSITY;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedIntensity($v)
	{

		if ($this->reported_intensity !== $v) {
			$this->reported_intensity = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_INTENSITY;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_VOLUME;
		}

	} 
	
	public function setLCcl($v)
	{

		if ($this->l_ccl !== $v) {
			$this->l_ccl = $v;
			$this->modifiedColumns[] = SessionPeer::L_CCL;
		}

	} 
	
	public function setCcl($v)
	{

		if ($this->ccl !== $v) {
			$this->ccl = $v;
			$this->modifiedColumns[] = SessionPeer::CCL;
		}

	} 
	
	public function setCcm($v)
	{

		if ($this->ccm !== $v) {
			$this->ccm = $v;
			$this->modifiedColumns[] = SessionPeer::CCM;
		}

	} 
	
	public function setUam($v)
	{

		if ($this->uam !== $v) {
			$this->uam = $v;
			$this->modifiedColumns[] = SessionPeer::UAM;
		}

	} 
	
	public function setMUam($v)
	{

		if ($this->m_uam !== $v) {
			$this->m_uam = $v;
			$this->modifiedColumns[] = SessionPeer::M_UAM;
		}

	} 
	
	public function setLact1($v)
	{

		if ($this->lact1 !== $v) {
			$this->lact1 = $v;
			$this->modifiedColumns[] = SessionPeer::LACT1;
		}

	} 
	
	public function setLact2($v)
	{

		if ($this->lact2 !== $v) {
			$this->lact2 = $v;
			$this->modifiedColumns[] = SessionPeer::LACT2;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->date = $rs->getDate($startcol + 1, null);

			$this->morning_session = $rs->getBoolean($startcol + 2);

			$this->feedback = $rs->getString($startcol + 3);

			$this->microcycle_id = $rs->getInt($startcol + 4);

			$this->wake_up_hr = $rs->getFloat($startcol + 5);

			$this->theoric_intensity = $rs->getFloat($startcol + 6);

			$this->theoric_volume = $rs->getFloat($startcol + 7);

			$this->reported_intensity = $rs->getFloat($startcol + 8);

			$this->reported_volume = $rs->getFloat($startcol + 9);

			$this->l_ccl = $rs->getFloat($startcol + 10);

			$this->ccl = $rs->getFloat($startcol + 11);

			$this->ccm = $rs->getFloat($startcol + 12);

			$this->uam = $rs->getFloat($startcol + 13);

			$this->m_uam = $rs->getFloat($startcol + 14);

			$this->lact1 = $rs->getFloat($startcol + 15);

			$this->lact2 = $rs->getFloat($startcol + 16);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 17; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Session object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SessionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aMicrocycle !== null) {
				if ($this->aMicrocycle->isModified()) {
					$affectedRows += $this->aMicrocycle->save($con);
				}
				$this->setMicrocycle($this->aMicrocycle);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SessionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SessionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collFeedbacks !== null) {
				foreach($this->collFeedbacks as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSessionElements !== null) {
				foreach($this->collSessionElements as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMicrocycle !== null) {
				if (!$this->aMicrocycle->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMicrocycle->getValidationFailures());
				}
			}


			if (($retval = SessionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collFeedbacks !== null) {
					foreach($this->collFeedbacks as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSessionElements !== null) {
					foreach($this->collSessionElements as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDate();
				break;
			case 2:
				return $this->getMorningSession();
				break;
			case 3:
				return $this->getFeedback();
				break;
			case 4:
				return $this->getMicrocycleId();
				break;
			case 5:
				return $this->getWakeUpHr();
				break;
			case 6:
				return $this->getTheoricIntensity();
				break;
			case 7:
				return $this->getTheoricVolume();
				break;
			case 8:
				return $this->getReportedIntensity();
				break;
			case 9:
				return $this->getReportedVolume();
				break;
			case 10:
				return $this->getLCcl();
				break;
			case 11:
				return $this->getCcl();
				break;
			case 12:
				return $this->getCcm();
				break;
			case 13:
				return $this->getUam();
				break;
			case 14:
				return $this->getMUam();
				break;
			case 15:
				return $this->getLact1();
				break;
			case 16:
				return $this->getLact2();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDate(),
			$keys[2] => $this->getMorningSession(),
			$keys[3] => $this->getFeedback(),
			$keys[4] => $this->getMicrocycleId(),
			$keys[5] => $this->getWakeUpHr(),
			$keys[6] => $this->getTheoricIntensity(),
			$keys[7] => $this->getTheoricVolume(),
			$keys[8] => $this->getReportedIntensity(),
			$keys[9] => $this->getReportedVolume(),
			$keys[10] => $this->getLCcl(),
			$keys[11] => $this->getCcl(),
			$keys[12] => $this->getCcm(),
			$keys[13] => $this->getUam(),
			$keys[14] => $this->getMUam(),
			$keys[15] => $this->getLact1(),
			$keys[16] => $this->getLact2(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDate($value);
				break;
			case 2:
				$this->setMorningSession($value);
				break;
			case 3:
				$this->setFeedback($value);
				break;
			case 4:
				$this->setMicrocycleId($value);
				break;
			case 5:
				$this->setWakeUpHr($value);
				break;
			case 6:
				$this->setTheoricIntensity($value);
				break;
			case 7:
				$this->setTheoricVolume($value);
				break;
			case 8:
				$this->setReportedIntensity($value);
				break;
			case 9:
				$this->setReportedVolume($value);
				break;
			case 10:
				$this->setLCcl($value);
				break;
			case 11:
				$this->setCcl($value);
				break;
			case 12:
				$this->setCcm($value);
				break;
			case 13:
				$this->setUam($value);
				break;
			case 14:
				$this->setMUam($value);
				break;
			case 15:
				$this->setLact1($value);
				break;
			case 16:
				$this->setLact2($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDate($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setMorningSession($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFeedback($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setMicrocycleId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setWakeUpHr($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTheoricIntensity($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setTheoricVolume($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setReportedIntensity($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setReportedVolume($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setLCcl($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setCcl($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setCcm($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setUam($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setMUam($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setLact1($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setLact2($arr[$keys[16]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SessionPeer::DATABASE_NAME);

		if ($this->isColumnModified(SessionPeer::ID)) $criteria->add(SessionPeer::ID, $this->id);
		if ($this->isColumnModified(SessionPeer::DATE)) $criteria->add(SessionPeer::DATE, $this->date);
		if ($this->isColumnModified(SessionPeer::MORNING_SESSION)) $criteria->add(SessionPeer::MORNING_SESSION, $this->morning_session);
		if ($this->isColumnModified(SessionPeer::FEEDBACK)) $criteria->add(SessionPeer::FEEDBACK, $this->feedback);
		if ($this->isColumnModified(SessionPeer::MICROCYCLE_ID)) $criteria->add(SessionPeer::MICROCYCLE_ID, $this->microcycle_id);
		if ($this->isColumnModified(SessionPeer::WAKE_UP_HR)) $criteria->add(SessionPeer::WAKE_UP_HR, $this->wake_up_hr);
		if ($this->isColumnModified(SessionPeer::THEORIC_INTENSITY)) $criteria->add(SessionPeer::THEORIC_INTENSITY, $this->theoric_intensity);
		if ($this->isColumnModified(SessionPeer::THEORIC_VOLUME)) $criteria->add(SessionPeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(SessionPeer::REPORTED_INTENSITY)) $criteria->add(SessionPeer::REPORTED_INTENSITY, $this->reported_intensity);
		if ($this->isColumnModified(SessionPeer::REPORTED_VOLUME)) $criteria->add(SessionPeer::REPORTED_VOLUME, $this->reported_volume);
		if ($this->isColumnModified(SessionPeer::L_CCL)) $criteria->add(SessionPeer::L_CCL, $this->l_ccl);
		if ($this->isColumnModified(SessionPeer::CCL)) $criteria->add(SessionPeer::CCL, $this->ccl);
		if ($this->isColumnModified(SessionPeer::CCM)) $criteria->add(SessionPeer::CCM, $this->ccm);
		if ($this->isColumnModified(SessionPeer::UAM)) $criteria->add(SessionPeer::UAM, $this->uam);
		if ($this->isColumnModified(SessionPeer::M_UAM)) $criteria->add(SessionPeer::M_UAM, $this->m_uam);
		if ($this->isColumnModified(SessionPeer::LACT1)) $criteria->add(SessionPeer::LACT1, $this->lact1);
		if ($this->isColumnModified(SessionPeer::LACT2)) $criteria->add(SessionPeer::LACT2, $this->lact2);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SessionPeer::DATABASE_NAME);

		$criteria->add(SessionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDate($this->date);

		$copyObj->setMorningSession($this->morning_session);

		$copyObj->setFeedback($this->feedback);

		$copyObj->setMicrocycleId($this->microcycle_id);

		$copyObj->setWakeUpHr($this->wake_up_hr);

		$copyObj->setTheoricIntensity($this->theoric_intensity);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedIntensity($this->reported_intensity);

		$copyObj->setReportedVolume($this->reported_volume);

		$copyObj->setLCcl($this->l_ccl);

		$copyObj->setCcl($this->ccl);

		$copyObj->setCcm($this->ccm);

		$copyObj->setUam($this->uam);

		$copyObj->setMUam($this->m_uam);

		$copyObj->setLact1($this->lact1);

		$copyObj->setLact2($this->lact2);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getFeedbacks() as $relObj) {
				$copyObj->addFeedback($relObj->copy($deepCopy));
			}

			foreach($this->getSessionElements() as $relObj) {
				$copyObj->addSessionElement($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SessionPeer();
		}
		return self::$peer;
	}

	
	public function setMicrocycle($v)
	{


		if ($v === null) {
			$this->setMicrocycleId(NULL);
		} else {
			$this->setMicrocycleId($v->getId());
		}


		$this->aMicrocycle = $v;
	}


	
	public function getMicrocycle($con = null)
	{
		if ($this->aMicrocycle === null && ($this->microcycle_id !== null)) {
						include_once 'lib/model/om/BaseMicrocyclePeer.php';

			$this->aMicrocycle = MicrocyclePeer::retrieveByPK($this->microcycle_id, $con);

			
		}
		return $this->aMicrocycle;
	}

	
	public function initFeedbacks()
	{
		if ($this->collFeedbacks === null) {
			$this->collFeedbacks = array();
		}
	}

	
	public function getFeedbacks($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFeedbacks === null) {
			if ($this->isNew()) {
			   $this->collFeedbacks = array();
			} else {

				$criteria->add(FeedbackPeer::SESSION_ID, $this->getId());

				FeedbackPeer::addSelectColumns($criteria);
				$this->collFeedbacks = FeedbackPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(FeedbackPeer::SESSION_ID, $this->getId());

				FeedbackPeer::addSelectColumns($criteria);
				if (!isset($this->lastFeedbackCriteria) || !$this->lastFeedbackCriteria->equals($criteria)) {
					$this->collFeedbacks = FeedbackPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFeedbackCriteria = $criteria;
		return $this->collFeedbacks;
	}

	
	public function countFeedbacks($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(FeedbackPeer::SESSION_ID, $this->getId());

		return FeedbackPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addFeedback(Feedback $l)
	{
		$this->collFeedbacks[] = $l;
		$l->setSession($this);
	}


	
	public function getFeedbacksJoinUnit($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFeedbacks === null) {
			if ($this->isNew()) {
				$this->collFeedbacks = array();
			} else {

				$criteria->add(FeedbackPeer::SESSION_ID, $this->getId());

				$this->collFeedbacks = FeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		} else {
									
			$criteria->add(FeedbackPeer::SESSION_ID, $this->getId());

			if (!isset($this->lastFeedbackCriteria) || !$this->lastFeedbackCriteria->equals($criteria)) {
				$this->collFeedbacks = FeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		}
		$this->lastFeedbackCriteria = $criteria;

		return $this->collFeedbacks;
	}

	
	public function initSessionElements()
	{
		if ($this->collSessionElements === null) {
			$this->collSessionElements = array();
		}
	}

	
	public function getSessionElements($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionElements === null) {
			if ($this->isNew()) {
			   $this->collSessionElements = array();
			} else {

				$criteria->add(SessionElementPeer::SESSION_ID, $this->getId());

				SessionElementPeer::addSelectColumns($criteria);
				$this->collSessionElements = SessionElementPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionElementPeer::SESSION_ID, $this->getId());

				SessionElementPeer::addSelectColumns($criteria);
				if (!isset($this->lastSessionElementCriteria) || !$this->lastSessionElementCriteria->equals($criteria)) {
					$this->collSessionElements = SessionElementPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSessionElementCriteria = $criteria;
		return $this->collSessionElements;
	}

	
	public function countSessionElements($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SessionElementPeer::SESSION_ID, $this->getId());

		return SessionElementPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSessionElement(SessionElement $l)
	{
		$this->collSessionElements[] = $l;
		$l->setSession($this);
	}


	
	public function getSessionElementsJoinWorkingMethod($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionElements === null) {
			if ($this->isNew()) {
				$this->collSessionElements = array();
			} else {

				$criteria->add(SessionElementPeer::SESSION_ID, $this->getId());

				$this->collSessionElements = SessionElementPeer::doSelectJoinWorkingMethod($criteria, $con);
			}
		} else {
									
			$criteria->add(SessionElementPeer::SESSION_ID, $this->getId());

			if (!isset($this->lastSessionElementCriteria) || !$this->lastSessionElementCriteria->equals($criteria)) {
				$this->collSessionElements = SessionElementPeer::doSelectJoinWorkingMethod($criteria, $con);
			}
		}
		$this->lastSessionElementCriteria = $criteria;

		return $this->collSessionElements;
	}

} 